#define INETCHANNEL_NAME "INetChannel"
#define INETCHANNEL_ID 5080

#include <GMLuaModule.h>

#include <eiface.h>
#include <cdll_int.h>
#include <inetchannel.h>

GMOD_MODULE(Load, Unload);

ILuaInterface *gLua = NULL;

IVEngineServer *sengine = NULL;
IVEngineClient *cengine = NULL;

int GetPlayerEIndex(ILuaObject *playerEntity)
{
	ILuaObject *entityMT = gLua->GetMetaTable("Entity", GLua::TYPE_ENTITY);
		entityMT->GetMember("EntIndex")->Push();
		
		playerEntity->Push();

		gLua->Call(1, 1);
	entityMT->UnReference();

	return (gLua->GetReturn(0)->GetInt());
}

LUA_FUNCTION(SendFile)
{
	gLua->CheckType(1, INETCHANNEL_ID);
	gLua->CheckType(2, GLua::TYPE_STRING);

	INetChannel *playerNC = (INetChannel*)gLua->GetUserData(1);

	gLua->Push(playerNC->SendFile(gLua->GetString(2), gLua->GetInteger(3)));

	return 1;
}

LUA_FUNCTION(RequestFile)
{
	gLua->CheckType(1, INETCHANNEL_ID);
	gLua->CheckType(2, GLua::TYPE_STRING);

	INetChannel *playerNC = (INetChannel*)gLua->GetUserData(1);

	gLua->PushDouble(playerNC->RequestFile(gLua->GetString(2)));

	return 1;
}

LUA_FUNCTION(GetINetChannel_Client)
{
	INetChannel *playerNC = (INetChannel*)cengine->GetNetChannelInfo();

	if (playerNC)
		gLua->PushUserData(gLua->GetMetaTable(INETCHANNEL_NAME, INETCHANNEL_ID), playerNC);
	else
		gLua->PushNil();

	return 1;
}

LUA_FUNCTION(GetINetChannel_Server)
{
	gLua->CheckType(1, GLua::TYPE_ENTITY);

	INetChannel *playerNC = (INetChannel*)sengine->GetPlayerNetInfo(GetPlayerEIndex(gLua->GetObject(1)));
	
	if (playerNC)
		gLua->PushUserData(gLua->GetMetaTable(INETCHANNEL_NAME, INETCHANNEL_ID), playerNC);
	else
		gLua->PushNil();

	return 1;
}

int Load(lua_State *L)
{
	gLua = Lua();

	CreateInterfaceFn interfaceFactory = Sys_GetFactory("engine.dll");
	
	if (gLua->IsClient())
	{
		cengine = (IVEngineClient*)interfaceFactory(VENGINE_CLIENT_INTERFACE_VERSION, NULL);
		
		gLua->SetGlobal("GetINetChannel", GetINetChannel_Client);
	}
	else
	{
		sengine = (IVEngineServer*)interfaceFactory(INTERFACEVERSION_VENGINESERVER, NULL);

		gLua->SetGlobal("GetINetChannel", GetINetChannel_Server);
	}

	ILuaObject *INetChannelMT = gLua->GetMetaTable(INETCHANNEL_NAME, INETCHANNEL_ID);
		ILuaObject  *__index = gLua->GetNewTable();	
			__index->SetMember("SendFile", SendFile);
			__index->SetMember("RequestFile", RequestFile);
			
			INetChannelMT->SetMember("__index", __index);
		__index->UnReference();
	INetChannelMT->UnReference();

	return 0;
}

int Unload(lua_State *L)
{
	return 0;
}